<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>morphorobotx: Factory Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">morphorobotx
   </div>
   <div id="projectbrief">morphorobotxsharedlibrary</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1.2 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Macros</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classFactory-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Factory Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="Factory_8hpp_source.html">Factory.hpp</a>&quot;</code></p>
<div class="dynheader">
Collaboration diagram for Factory:</div>
<div class="dyncontent">
<div class="center"><img src="classFactory__coll__graph.png" border="0" usemap="#Factory_coll__map" alt="Collaboration graph"/></div>
</div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a4afdb23e17512b236a563707beb7c2b7"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFactory.html#a4afdb23e17512b236a563707beb7c2b7">register_protocol</a> (QString name, std::shared_ptr&lt; <a class="el" href="structProtocolMaker.html">ProtocolMaker</a> &gt; proc)</td></tr>
<tr class="memitem:a3ce9afdf669ae1f9a4dd9b9a9af45cd9"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFactory.html#a3ce9afdf669ae1f9a4dd9b9a9af45cd9">unregister_protocol</a> (QString name, std::shared_ptr&lt; <a class="el" href="structProtocolMaker.html">ProtocolMaker</a> &gt; proc)</td></tr>
<tr class="memitem:aecc4c03b2954c223b8596f5a5f61ee7b"><td class="memItemLeft" align="right" valign="top">std::shared_ptr&lt; <a class="el" href="structProtocol.html">Protocol</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFactory.html#aecc4c03b2954c223b8596f5a5f61ee7b">protocol</a> (QString name, <a class="el" href="classExperiment.html">Experiment</a> &amp;experiment)</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:aa3472cb7ee0cf2a3368b9127a6dba236"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classFactory.html">Factory</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFactory.html#aa3472cb7ee0cf2a3368b9127a6dba236">instance</a> ()</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:ac792bf88cfb7b6804b479529da5308cc"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFactory.html#ac792bf88cfb7b6804b479529da5308cc">Factory</a> ()</td></tr>
<tr class="memitem:a3134affec6585ba3c98f25bf2f9839ac"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFactory.html#a3134affec6585ba3c98f25bf2f9839ac">Factory</a> (const <a class="el" href="classFactory.html">Factory</a> &amp;copy)</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a7c27626c281e8d2223344391a7867524"><td class="memItemLeft" align="right" valign="top">QHash&lt; QString, <br class="typebreak"/>
std::shared_ptr&lt; <a class="el" href="structProtocolMaker.html">ProtocolMaker</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFactory.html#a7c27626c281e8d2223344391a7867524">protocoles</a></td></tr>
</table>
<a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Main factory class. This is the interface through which all the protocoles should be created. </p>
</div><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ac792bf88cfb7b6804b479529da5308cc"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Factory::Factory </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Creation of the factory is a private matter </p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="classFactory_ac792bf88cfb7b6804b479529da5308cc_icgraph.png" border="0" usemap="#classFactory_ac792bf88cfb7b6804b479529da5308cc_icgraph" alt=""/></div>
<map name="classFactory_ac792bf88cfb7b6804b479529da5308cc_icgraph" id="classFactory_ac792bf88cfb7b6804b479529da5308cc_icgraph">
<area shape="rect" id="node3" href="classFactory.html#aa3472cb7ee0cf2a3368b9127a6dba236" title="Factory::instance" alt="" coords="173,67,296,96"/><area shape="rect" id="node5" href="Factory_8hpp.html#a260e511783256d65c1e55ed23434f7c9" title="factory" alt="" coords="345,67,407,96"/><area shape="rect" id="node7" href="classExperiment.html#a2666b3fed68eef734107a0251ce405ce" title="Experiment::Initialize" alt="" coords="463,5,607,35"/><area shape="rect" id="node9" href="structProtocolRegistration.html#ad14be68e5a3a949a135f869c545ef007" title="ProtocolRegistration\l::ProtocolRegistration" alt="" coords="461,58,608,105"/><area shape="rect" id="node11" href="structProtocolRegistration.html#ad7b35e71798516005186500959c3f0fa" title="ProtocolRegistration\l::~ProtocolRegistration" alt="" coords="457,127,612,174"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a3134affec6585ba3c98f25bf2f9839ac"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Factory::Factory </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classFactory.html">Factory</a> &amp;&#160;</td>
          <td class="paramname"><em>copy</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Forbid copy of the factory </p>

</div>
</div>
<h2>Member Function Documentation</h2>
<a class="anchor" id="aa3472cb7ee0cf2a3368b9127a6dba236"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classFactory.html">Factory</a> &amp; Factory::instance </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Get/create the singleton instance of the factory </p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="classFactory_aa3472cb7ee0cf2a3368b9127a6dba236_cgraph.png" border="0" usemap="#classFactory_aa3472cb7ee0cf2a3368b9127a6dba236_cgraph" alt=""/></div>
<map name="classFactory_aa3472cb7ee0cf2a3368b9127a6dba236_cgraph" id="classFactory_aa3472cb7ee0cf2a3368b9127a6dba236_cgraph">
<area shape="rect" id="node3" href="classFactory.html#ac792bf88cfb7b6804b479529da5308cc" title="Factory::Factory" alt="" coords="177,5,295,35"/></map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="classFactory_aa3472cb7ee0cf2a3368b9127a6dba236_icgraph.png" border="0" usemap="#classFactory_aa3472cb7ee0cf2a3368b9127a6dba236_icgraph" alt=""/></div>
<map name="classFactory_aa3472cb7ee0cf2a3368b9127a6dba236_icgraph" id="classFactory_aa3472cb7ee0cf2a3368b9127a6dba236_icgraph">
<area shape="rect" id="node3" href="Factory_8hpp.html#a260e511783256d65c1e55ed23434f7c9" title="factory" alt="" coords="177,67,239,96"/><area shape="rect" id="node5" href="classExperiment.html#a2666b3fed68eef734107a0251ce405ce" title="Experiment::Initialize" alt="" coords="295,5,439,35"/><area shape="rect" id="node7" href="structProtocolRegistration.html#ad14be68e5a3a949a135f869c545ef007" title="ProtocolRegistration\l::ProtocolRegistration" alt="" coords="293,58,440,105"/><area shape="rect" id="node9" href="structProtocolRegistration.html#ad7b35e71798516005186500959c3f0fa" title="ProtocolRegistration\l::~ProtocolRegistration" alt="" coords="289,127,444,174"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="aecc4c03b2954c223b8596f5a5f61ee7b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="structProtocol.html">Protocol</a> &gt; Factory::protocol </td>
          <td>(</td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classExperiment.html">Experiment</a> &amp;&#160;</td>
          <td class="paramname"><em>experiment</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Create a protocol </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>Name of the protocol to create </td></tr>
    <tr><td class="paramname">experiment</td><td><a class="el" href="classExperiment.html">Experiment</a> running the protocol </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A shared pointer to the newly created protocol </dd></dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="classFactory_aecc4c03b2954c223b8596f5a5f61ee7b_icgraph.png" border="0" usemap="#classFactory_aecc4c03b2954c223b8596f5a5f61ee7b_icgraph" alt=""/></div>
<map name="classFactory_aecc4c03b2954c223b8596f5a5f61ee7b_icgraph" id="classFactory_aecc4c03b2954c223b8596f5a5f61ee7b_icgraph">
<area shape="rect" id="node3" href="classExperiment.html#a2666b3fed68eef734107a0251ce405ce" title="Experiment::Initialize" alt="" coords="173,5,317,35"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a4afdb23e17512b236a563707beb7c2b7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Factory::register_protocol </td>
          <td>(</td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="structProtocolMaker.html">ProtocolMaker</a> &gt;&#160;</td>
          <td class="paramname"><em>proc</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Register a new protocol </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>Name of the protocol </td></tr>
    <tr><td class="paramname">proc</td><td><a class="el" href="structProtocol.html">Protocol</a> maker of the specific protocol type </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>False if the protocol name is already in use </dd></dl>

</div>
</div>
<a class="anchor" id="a3ce9afdf669ae1f9a4dd9b9a9af45cd9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Factory::unregister_protocol </td>
          <td>(</td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="structProtocolMaker.html">ProtocolMaker</a> &gt;&#160;</td>
          <td class="paramname"><em>proc</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Un-register a protocol </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>Name of the protocol </td></tr>
    <tr><td class="paramname">proc</td><td>Instance of the protocol maker to remove </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>False if the name doesn't exist or if <code>proc</code> doesn't correspond to this name </dd></dl>

</div>
</div>
<h2>Member Data Documentation</h2>
<a class="anchor" id="a7c27626c281e8d2223344391a7867524"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">QHash&lt;QString, std::shared_ptr&lt;<a class="el" href="structProtocolMaker.html">ProtocolMaker</a>&gt; &gt; Factory::protocoles</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Dictionnary of all the known protocoles </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="Factory_8hpp_source.html">Factory.hpp</a></li>
<li><a class="el" href="Factory_8cpp.html">Factory.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Feb 26 2013 17:54:10 for morphorobotx by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1.2
</small></address>
</body>
</html>
